searchNodes=[{"doc":"An API of the raft consensus algorithm, allowing for custom client requests and custom replicated state machines. Example Let&#39;s create a distributed stack. The first step is to set up the state machine. Here we will use the Graft.Machine behaviour. defmodule MyStackMachine do use Graft.Machine @impl Graft.Machine def init([]) do {:ok, []} end @impl Graft.Machine def handle_entry({:put, value}, state) do {:ok, [value | state]} end def handle_entry(:pop, []) do {:noop, []} end def handle_entry(:pop, [response | state]) do {response, state} end def handle_entry(_, state) do {:invalid_request, state} end end Now that we have our state machine, we can define the servers that will make up the raft cluster. Each server must have a unique name. servers = [:server1, :server2, :server3] With both the servers and state machine, we can now run the graft funtion, which will start the servers and the consensus algorithm. {:ok, supervisor} = Graft.start servers, MyStackMachine Graft.start returns the supervisor pid from which we can terminate or restart the servers. We can now use Graft.request to make requests to our consensus cluster. As long as we know at least one server, we can send requests, since the Graft.Client module will forward the request if the server we choose is not the current leader. Graft.request :server1, :pop #=&gt; :noop Graft.request :server1, {:put, :foo} #=&gt; :ok Graft.request :server1, :pop #=&gt; :foo Graft.request :server1, :bar #=&gt; :invalid_request That completes the distributed stack.","ref":"Graft.html","title":"Graft","type":"module"},{"doc":"Print out the internal state of the server.","ref":"Graft.html#data/1","title":"Graft.data/1","type":"function"},{"doc":"Make a new client request to a server within the consensus cluster. server - name of the server the request should be sent to. &#39;entry&#39; - processed and applied by the replicated state machine.","ref":"Graft.html#request/2","title":"Graft.request/2","type":"function"},{"doc":"Starts the raft cluster. servers - list of server names. machine_module - module using the Graft.Machine behaviour to define the replicated state machine. machine_args - an optional list of arguments that are passed to the init function of the machine. Returns {:ok, pid} where pid is the supervisor pid which can be used to supervise the cluster&#39;s servers.","ref":"Graft.html#start/3","title":"Graft.start/3","type":"function"},{"doc":"A behaviour module for implementing a replicated machine for the raft consensus algorithm. Look at the Graft module docs for examples on how to create such machines.","ref":"Graft.Machine.html","title":"Graft.Machine","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Graft.Machine.html#child_spec/1","title":"Graft.Machine.child_spec/1","type":"function"},{"doc":"Invoked when a server in the raft cluster is commiting an entry to its log. Should apply the entry to the replicated machine. Should return a tuple of the response for the server along with the new state of the replicated machine.","ref":"Graft.Machine.html#c:handle_entry/2","title":"Graft.Machine.handle_entry/2","type":"callback"},{"doc":"Invoked when the server starts and links to the machine. args is a list accepted arguments. Look at Graft.start to see how to pass in these optional arguments. Returning {:ok, state}, will initialise the state of the machine to state.","ref":"Graft.Machine.html#c:init/1","title":"Graft.Machine.init/1","type":"callback"},{"doc":"The entry request sent by the client.","ref":"Graft.Machine.html#t:entry/0","title":"Graft.Machine.entry/0","type":"type"},{"doc":"The reply to be sent back to the client.","ref":"Graft.Machine.html#t:response/0","title":"Graft.Machine.response/0","type":"type"},{"doc":"The state/data of the replicated machine (similar to the &#39;state&#39; of GenServer).","ref":"Graft.Machine.html#t:state/0","title":"Graft.Machine.state/0","type":"type"}]